# Class BaseRemoteMethod<ReturnType, Parameter, Metadata>`Abstract`

#### Type Parameters

- ReturnType = any
- Parameter = any
- Metadata extends BaseRemoteMethodMetadata = BaseRemoteMethodMetadata

#### Hierarchy (view full)

- BaseDefinition<Metadata>
  - BaseRemoteMethod
    - ProxyRemoteMethod

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:38

#####
Index

### Constructors

constructor

### Properties

__id
_initialised
_pauseRefresh
destroyed$
executed$
executionsInProgress$
initialised$
injector
interceptors
metadata
destroyed$
initialised$
instances

### Accessors

id

### Methods

_call
applyMetadata
call
destroy
executed
getMetadata
init
ngOnDestroy
pauseRefresh
refresh
resumeRefresh
add
remove

## Constructors

### constructor

- new BaseRemoteMethod<ReturnType, Parameter, Metadata>(injector?, metaData?): BaseRemoteMethod<ReturnType, Parameter, Metadata>

- #### Type Parameters

  - ReturnType = any
  - Parameter = any
  - Metadata extends BaseRemoteMethodMetadata = BaseRemoteMethodMetadata

  #### Parameters

  - injector: Injector = null
  - metaData: any = null

  #### Returns BaseRemoteMethod<ReturnType, Parameter, Metadata>

  Overrides BaseDefinition<Metadata>.constructor

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:50

## Properties

### `Internal` __id

__id: string = ...

unique internal id

Inherited from BaseDefinition.__id

- Defined in packages/angular/definition/src/lib/definition.ts:61

### `Protected` _initialised

_initialised: boolean = false

Inherited from BaseDefinition._initialised

- Defined in packages/angular/definition/src/lib/definition.ts:62

### `Private` _pauseRefresh

_pauseRefresh: boolean = false

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:48

### `Readonly` destroyed$

destroyed$: Subject<void> = ...

Emits if the data source is destroyed

Inherited from BaseDefinition.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:48

### executed$

executed$: Subject<ReturnType> = ...

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:42

### executionsInProgress$

executionsInProgress$: CounterSubject = ...

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:44

### `Readonly` initialised$

initialised$: Subject<void> = ...

Emits if the data source is initialised

Inherited from BaseDefinition.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:52

### `Readonly` injector

injector: Injector

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:46

### `Readonly` interceptors

interceptors: Set<Subject<any>> = ...

Inherited from BaseDefinition.interceptors

- Defined in packages/angular/definition/src/lib/definition.ts:53

### metadata

metadata: Metadata

Inherited from BaseDefinition.metadata

- Defined in packages/angular/definition/src/lib/definition.ts:44

### `Static` `Readonly` destroyed$

destroyed$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseDefinition.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:41

### `Static` `Readonly` initialised$

initialised$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseDefinition.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:35

### `Static` `Readonly` instances

instances: Map<string, BaseDefinition<BaseDefinitionMetadata>> = ...

A map of active Definition instances

Inherited from BaseDefinition.instances

- Defined in packages/angular/definition/src/lib/definition.ts:27

## Accessors

### id

- get id(): string

- #### Returns string

  Inherited from BaseDefinition.id

  - Defined in packages/angular/definition/src/lib/definition.ts:87

## Methods

### `Protected` `Abstract` _call

- _call(parameters?): ReturnType | Promise<ReturnType>

- #### Parameters

  - `Optional` parameters: Parameter

  #### Returns ReturnType | Promise<ReturnType>

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:111

### applyMetadata

- applyMetadata(partialMetadata): void

- #### Parameters

  - partialMetadata: Partial<Metadata>

  #### Returns void

  Inherited from BaseDefinition.applyMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:111

### call

- call(parameters?): Promise<ReturnType>

- #### Parameters

  - `Optional` parameters: Parameter

  #### Returns Promise<ReturnType>

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:76

### destroy

- destroy(): void

- #### Returns void

  #### Deprecated

  use ngOnDestroy instead

  Inherited from BaseDefinition.destroy

  - Defined in packages/angular/definition/src/lib/definition.ts:118

### executed

- executed(result): void

- #### Parameters

  - result: ReturnType

  #### Returns void

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:86

### getMetadata

- getMetadata(): Metadata

- #### Returns Metadata

  Inherited from BaseDefinition.getMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:107

### init

- init(): void

- #### Returns void

  Inherited from BaseDefinition.init

  - Defined in packages/angular/definition/src/lib/definition.ts:127

### ngOnDestroy

- ngOnDestroy(): void

- #### Returns void

  Inherited from BaseDefinition.ngOnDestroy

  - Defined in packages/angular/definition/src/lib/definition.ts:122

### pauseRefresh

- pauseRefresh(): void

- #### Returns void

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:92

### refresh

- refresh(): void

- #### Returns void

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:100

### resumeRefresh

- resumeRefresh(): void

- #### Returns void

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:96

### `Static` add

- add(definition): void

- #### Parameters

  - definition: BaseDefinition<BaseDefinitionMetadata>

  #### Returns void

  Inherited from BaseDefinition.add

  - Defined in packages/angular/definition/src/lib/definition.ts:94

### `Static` remove

- remove(definition): void

- #### Parameters

  - definition: BaseDefinition<BaseDefinitionMetadata>

  #### Returns void

  Inherited from BaseDefinition.remove

  - Defined in packages/angular/definition/src/lib/definition.ts:102